=== docs/CMakeLists.txt ===

ADD_SUBDIRECTORY(man)

IF (REGINA_BUILD_ENGINE_DOCS)
  ADD_SUBDIRECTORY(engine)
ENDIF (REGINA_BUILD_ENGINE_DOCS)
