=== qtui/CMakeLists.txt ===

ADD_SUBDIRECTORY(src)

IF (REGINA_BUILD_HANDBOOK)
  ADD_SUBDIRECTORY(doc)
ENDIF (REGINA_BUILD_HANDBOOK)
