=== debian/changelog ===
regina-normal (7.4-1) unstable; urgency=low

  * New upstream release.
  * No longer build-depends on libcppunit-dev, libjansson-dev or libpopt-dev.

 -- Ben Burton <bab@debian.org>  Tue, 26 Aug 2025 19:12:53 +1000
