=== debian/tests/control ===
Test-Command: debian/tests/utils-test censuslookup
Features: test-name=utils-censuslookup
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regconcat
Features: test-name=utils-regconcat
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regconvert
Features: test-name=utils-regconvert
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regfiledump
Features: test-name=utils-regfiledump
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regfiletype
Features: test-name=utils-regfiletype
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test retriangulate
Features: test-name=utils-retriangulate
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test sigcensus
Features: test-name=utils-sigcensus
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test tricensus
Features: test-name=utils-tricensus
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test trisetcmp
Features: test-name=utils-trisetcmp
Depends: @, bsdextrautils

Test-Command: debian/tests/python-test alltypes
Features: test-name=python-alltypes

Test-Command: debian/tests/python-test alltypes-exc
Features: test-name=python-alltypes

Test-Command: debian/tests/python-test alltypes-noexc
Features: test-name=python-alltypes

Test-Command: debian/tests/python-test angles
Features: test-name=python-angles

Test-Command: debian/tests/python-test arrow
Features: test-name=python-angles

Test-Command: debian/tests/python-test base64
Features: test-name=python-bool

Test-Command: debian/tests/python-test binom
Features: test-name=python-bool

Test-Command: debian/tests/python-test bool
Features: test-name=python-bool

Test-Command: debian/tests/python-test bytes
Features: test-name=python-bytes

Test-Command: debian/tests/python-test callbacks
Features: test-name=python-callbacks

Test-Command: debian/tests/python-test census
Features: test-name=python-census

Test-Command: debian/tests/python-test clone
Features: test-name=python-clone

Test-Command: debian/tests/python-test comparison
Features: test-name=python-clone

Test-Command: debian/tests/python-test construction
Features: test-name=python-clone

Test-Command: debian/tests/python-test constructors
Features: test-name=python-constructors

Test-Command: debian/tests/python-test discs
Features: test-name=python-discs

Test-Command: debian/tests/python-test docstrings
Features: test-name=python-docstrings

Test-Command: debian/tests/python-test embeddings
Features: test-name=python-embeddings

Test-Command: debian/tests/python-test enumerate
Features: test-name=python-enumerate

Test-Command: debian/tests/python-test equality
Features: test-name=python-equality

Test-Command: debian/tests/python-test euler
Features: test-name=python-euler

Test-Command: debian/tests/python-test exception
Features: test-name=python-exception

Test-Command: debian/tests/python-test facenumbering
Features: test-name=python-facenumbering
