=== debian/watch ===
version=4
opts="searchmode=plain,\
  filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
  https://api.github.com/repos/regina-normal/regina/releases?per_page=50 \
  https://github.com/regina-normal/regina/releases/download/[^/]+/regina-@ANY_VERSION@@ARCHIVE_EXT@
