## regina-normal 7.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 INCLUDE( ReginaMacros )
 
 # Version
-SET (PACKAGE_VERSION 7.4)
+SET (PACKAGE_VERSION 7.4.1)
 SET (SNAPPY_VERSION 3.0.3)
 SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")
