=== engine/CMakeLists.txt ===
--- 
+++ 
@@ -105,12 +105,12 @@
   LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}"
   RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}"
   COMPONENT Runtime)
-INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/engine/regina-helper" DESTINATION bin)
+INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/engine/regina-helper" DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")
 
 if (${REGINA_INSTALL_DEV})
   INSTALL(FILES ${HEADERS} DESTINATION "${PKGINCLUDEDIR}" COMPONENT Development)
   INSTALL(FILES "${CMAKE_BINARY_DIR}/engine/regina-config.h" DESTINATION "${PKGINCLUDEDIR}" COMPONENT Development)
-  INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/engine/regina-engine-config" DESTINATION bin COMPONENT Development)
+  INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/engine/regina-engine-config" DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}" COMPONENT Development)
 endif (${REGINA_INSTALL_DEV})
 
 # Miscellaneous extras:
