=== debian/changelog ===
regina-normal (7.4.1-1~bpo12+1~regina1) bookworm; urgency=low

  * New upstream release, packaged for bookworm.

 -- Ben Burton <bab@debian.org>  Thu, 27 Nov 2025 07:20:24 +1000
