=== debian/rules ===
--- 
+++ 
@@ -3,8 +3,8 @@
 	dh $@ --with python3
 
 # Upgrade optimisation flags:
-export DEB_CFLAGS_MAINT_STRIP = -O2
-export DEB_CXXFLAGS_MAINT_STRIP = -O2
+export DEB_CFLAGS_MAINT_STRIP = -O2 -g
+export DEB_CXXFLAGS_MAINT_STRIP = -O2 -g
 export DEB_CFLAGS_MAINT_APPEND = -O3 -DNDEBUG
 export DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
 
@@ -18,11 +18,14 @@
 	dh_auto_configure -- \
 		-DPACKAGE_NAME=regina-normal -DPACKAGING_MODE=1 \
 		-DPython_EXECUTABLE=/usr/bin/python${pyver} \
-		-DBUILD_INFO="Debian package build" \
+		-DBUILD_INFO="Upstream Debian 12 package" \
 		-DDISABLE_RPATH=1
 
 override_dh_auto_build:
 	dh_auto_build -- VERBOSE=1
+	# The python debug symbols are obscenely large and are
+	# filling my virtual hard drive.
+	strip "obj-${DEB_BUILD_GNU_TYPE}"/python/regina/engine.so
 
 override_dh_auto_test:
 	dh_auto_test -- ARGS=-V
